(**************************************************************************)
(*                                                                        *)
(*  Menhir                                                                *)
(*                                                                        *)
(*  Franois Pottier, INRIA Rocquencourt                                  *)
(*  Yann Rgis-Gianas, PPS, Universit Paris Diderot                      *)
(*                                                                        *)
(*  Copyright 2005-2008 Institut National de Recherche en Informatique    *)
(*  et en Automatique. All rights reserved. This file is distributed      *)
(*  under the terms of the Q Public License version 1.0, with the change  *)
(*  described in file LICENSE.                                            *)
(*                                                                        *)
(**************************************************************************)

(* The natural numbers, completed with [Infinity], and ordered towards
   zero (i.e. [Infinity] is [bottom], [Finite 0] is [top]). *)

type t =
| Finite of int
| Infinity

include Fix.PROPERTY with type property = t

val min: t -> t -> t
val add: t -> t -> t

val min_lazy: t -> t Lazy.t -> t
val add_lazy: t -> t Lazy.t -> t

val print: t -> string
